#include <windows.h>
#include <stdio.h>
#include <initguid.h>
#define D3D_OVERLOADS
#include <ddraw.h>
#include <d3d.h>                        

#define RELEASE(x) if (x) { (x)->Release(); (x)=NULL; }
#define PI 3.141592654
#define XRES 800
#define YRES 600

HWND hwnd;
MSG messages;
WNDCLASS wincl; 
BOOL bQuit=FALSE;
char szClassName[ ] = "WindowsApp";
// prototypes
LRESULT CALLBACK WindowProcedure(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam);

// DirectX
LPDIRECTDRAW dxdd;
DDSURFACEDESC dxsd;
D3DVIEWPORT dxviewport;
LPDIRECTDRAWSURFACE dxprimary = NULL;
LPDIRECTDRAWSURFACE dxbackbuffer = NULL;
LPDIRECTDRAWSURFACE dxzbuffer = NULL;
LPDIRECT3D2 dxd3d = NULL;
LPDIRECT3DDEVICE2 dxd3ddevice = NULL;
LPDIRECT3DVIEWPORT2 dxd3dviewport = NULL;
DDBLTFX dxblt;
// lighting
LPDIRECT3DLIGHT dxd3dlight;
D3DLIGHT dxlight;
LPDIRECT3DMATERIAL2 dxd3dmat;
D3DMATERIAL dxmat;
D3DMATERIALHANDLE dxhmat;
// texturing
D3DTEXTUREHANDLE dxhtexture[2];
LPDIRECTDRAWSURFACE dxstexture;
LPDIRECT3DTEXTURE2 dxtexture;
HDC dxtexturedc;
// transforming
D3DMATRIX matrix;

// time
float t;

// My DX Funcs
#define DXXRESULT(a,b,c) -((a.y-b.y)*(c.z-b.z)-(a.z-b.z)*(c.y-b.y))
#define DXYRESULT(a,b,c) -((a.z-b.z)*(c.x-b.x)-(a.x-b.x)*(c.z-b.z))
#define DXZRESULT(a,b,c) -((a.x-b.x)*(c.y-b.y)-(a.y-b.y)*(c.x-b.x))
#define DXNORM(a,b,c) dxfix(DXXRESULT(a,b,c),DXYRESULT(a,b,c),DXZRESULT(a,b,c))

struct dxtriangle {
  long num;
  D3DVERTEX* v;
  unsigned tex;
};

struct dx3dobject {
  long lists, strips, fans;
  dxtriangle *list, *strip, *fan;
} obj;

D3DVECTOR dxfix(float x, float y, float z){
  float len=sqrt(x*x+y*y+z*z);
  D3DVECTOR v=D3DVECTOR(x/len, y/len, z/len);
  return v;
}

void status(char* s){
  FILE *f;
  f=fopen("status.txt", "w");
  fseek(f, 0, SEEK_SET);
  fwrite( s, sizeof(s), 1, f);
  fclose(f);
}

void dxloadobject(char* fname){
  FILE *f;
  unsigned short typ;
  float scalex, scaley, scalez, fl;
  D3DVECTOR v[3];
  float tu[3], tv[3];
  obj.lists=obj.strips=obj.fans=0;
  obj.list=NULL;
  obj.strip=NULL;
  obj.fan=NULL;
  f=fopen(fname, "rb");
  fseek(f, 0, SEEK_SET);
  while(!feof(f)){
    fread(&typ, 2, 1, f);
    if(typ==0){
//      fread(&fl, 4, 1, f);
//      obj.data=(dxtriangle*)malloc(obj.triangles*sizeof(dxtriangle));
      fread(&scalex, 4, 1, f);
      fread(&scaley, 4, 1, f);
      fread(&scalez, 4, 1, f);
    }
    if(typ==1){
      obj.lists++;
      if(obj.list==NULL){
        obj.list=(dxtriangle*)malloc(obj.lists*sizeof(dxtriangle));
      } else {
        obj.list=(dxtriangle*)realloc(obj.list, obj.lists*sizeof(dxtriangle));
      }
      fread(&fl, 4, 1, f);obj.list[obj.lists-1].num=(long)fl;
      fread(&fl, 4, 1, f);obj.list[obj.lists-1].tex=(unsigned)fl;
      obj.list[obj.lists-1].v=(D3DVERTEX*)malloc(obj.list[obj.lists-1].num*sizeof(D3DVERTEX));
      for(int i=0;i<obj.list[obj.lists-1].num/3;i++){
        for(int j=0;j<3;j++){
          fread(&fl, 4, 1, f);v[j].x=scalex*fl;
          fread(&fl, 4, 1, f);v[j].y=scaley*fl;
          fread(&fl, 4, 1, f);v[j].z=scalez*fl;
          fread(&tu[j], 4, 1, f);
          fread(&tv[j], 4, 1, f);
        }
        for(int j=0;j<3;j++){
          obj.list[obj.lists-1].v[i*3+j]=D3DVERTEX(v[j], DXNORM(v[0], v[1], v[2]),tu[j], tv[j]);
        }  
      }
    }
    if(typ==2){
      obj.strips++;
      if(obj.strip==NULL){
        obj.strip=(dxtriangle*)malloc(obj.strips*sizeof(dxtriangle));
      } else {
        obj.strip=(dxtriangle*)realloc(obj.strip, obj.strips*sizeof(dxtriangle));
      }
      fread(&fl, 4, 1, f);obj.strip[obj.strips-1].num=(long)fl;
      fread(&fl, 4, 1, f);obj.strip[obj.strips-1].tex=(unsigned)fl;
      obj.strip[obj.strips-1].v=(D3DVERTEX*)malloc(obj.strip[obj.strips-1].num*sizeof(D3DVERTEX));
      // first 3
      for(int i=0;i<3;i++){
        fread(&fl, 4, 1, f);v[i].x=scalex*fl;
        fread(&fl, 4, 1, f);v[i].y=scaley*fl;
        fread(&fl, 4, 1, f);v[i].z=scalez*fl;
        fread(&tu[i], 4, 1, f);
        fread(&tv[i], 4, 1, f);
      }
      for(int i=0;i<3;i++){
        obj.strip[obj.strips-1].v[i]=D3DVERTEX(v[i], DXNORM(v[0], v[1], v[2]),tu[i], tv[i]);
      }  
      if(obj.strip[obj.strips-1].num>3){
        for(int i=3;i<obj.strip[obj.strips-1].num;i++){
          fread(&fl, 4, 1, f);v[(i-3)%3].x=scalex*fl;
          fread(&fl, 4, 1, f);v[(i-3)%3].y=scaley*fl;
          fread(&fl, 4, 1, f);v[(i-3)%3].z=scalez*fl;
          fread(&tu[(i-3)%3], 4, 1, f);
          fread(&tv[(i-3)%3], 4, 1, f);
          if(i%2==0){
            obj.strip[obj.strips-1].v[i]=D3DVERTEX(v[(i-3)%3], DXNORM(v[0], v[1], v[2]),tu[(i-3)%3], tv[(i-3)%3]);
          } else {
            obj.strip[obj.strips-1].v[i]=D3DVERTEX(v[(i-3)%3], DXNORM(v[1], v[0], v[2]),tu[(i-3)%3], tv[(i-3)%3]);
          }
        }
      }
    }
  }
  fclose(f);
}

void dxcleanup(void){
  if (dxd3ddevice && dxd3dviewport){
    dxd3ddevice->DeleteViewport(dxd3dviewport);
  }
  RELEASE(dxd3dviewport);
  RELEASE(dxd3ddevice);
  RELEASE(dxd3d);
  RELEASE(dxprimary);
  RELEASE(dxdd);
}

void dxerror(void){
  RELEASE(dxdd);
  dxcleanup();
  DestroyWindow(hwnd);
  exit(0);
}

void winerror(void){
  DestroyWindow(hwnd);
  exit(0);
}

void dxinit(void){
  // Init DirectX and Direct3D
  // create direct draw object on primary surface
  if (DirectDrawCreate(NULL, &dxdd, NULL )!=DD_OK) dxerror();
  // set the cooperative level
  if (dxdd->SetCooperativeLevel(hwnd, DDSCL_FULLSCREEN  | DDSCL_EXCLUSIVE | DDSCL_ALLOWMODEX)!=DD_OK) dxerror();
  dxdd->SetDisplayMode(XRES,YRES,32);
  // create the primary surface
  ZeroMemory(&dxsd, sizeof(dxsd));
  dxsd.dwSize = sizeof(dxsd);
  dxsd.dwFlags = DDSD_CAPS;
  dxsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE|DDSCAPS_VIDEOMEMORY;
  if (dxdd->CreateSurface(&dxsd, &dxprimary, NULL )!=DD_OK){
    dxsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE|DDSCAPS_SYSTEMMEMORY;
    if (dxdd->CreateSurface(&dxsd, &dxprimary, NULL )!=DD_OK) dxerror();
  }
  // Create backbuffer
  ZeroMemory(&dxsd, sizeof(dxsd));
  dxsd.dwSize = sizeof(dxsd);
  dxsd.dwFlags = DDSD_CAPS | DDSD_WIDTH | DDSD_HEIGHT;
  dxsd.dwWidth = XRES;
  dxsd.dwHeight = YRES;
  dxsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN | DDSCAPS_3DDEVICE | DDSCAPS_VIDEOMEMORY;
  if (dxdd->CreateSurface(&dxsd, &dxbackbuffer, NULL) != DD_OK){
    dxsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN | DDSCAPS_3DDEVICE | DDSCAPS_SYSTEMMEMORY;
    if (dxdd->CreateSurface(&dxsd, &dxbackbuffer, NULL) != DD_OK) dxerror();
  }
  if (dxprimary->AddAttachedSurface(dxbackbuffer) != DD_OK) dxerror();
  // Create a z-buffer and attach it to the backbuffer
  ZeroMemory(&dxsd, sizeof(dxsd));
  dxsd.dwSize = sizeof(dxsd);
  dxsd.dwFlags = DDSD_CAPS | DDSD_WIDTH | DDSD_HEIGHT | DDSD_ZBUFFERBITDEPTH;
  dxsd.dwWidth = XRES;
  dxsd.dwHeight = YRES;
  dxsd.dwZBufferBitDepth = 16;
  dxsd.ddsCaps.dwCaps = DDSCAPS_ZBUFFER | DDSCAPS_VIDEOMEMORY;
  if (dxdd->CreateSurface(&dxsd, &dxzbuffer, NULL) != DD_OK){
    dxsd.ddsCaps.dwCaps = DDSCAPS_ZBUFFER | DDSCAPS_SYSTEMMEMORY;
    if (dxdd->CreateSurface(&dxsd, &dxzbuffer, NULL) != DD_OK) dxerror();
  }  
  if (dxbackbuffer->AddAttachedSurface(dxzbuffer) != DD_OK) dxerror();
  // get the direct3d object
  if (dxdd->QueryInterface(IID_IDirect3D2, (LPVOID*)&dxd3d)!=DD_OK) dxerror();
  // create the direct 3d device from the surface
  if (dxd3d->CreateDevice(IID_IDirect3DHALDevice,dxbackbuffer, &dxd3ddevice)!=DD_OK){
    if (dxd3d->CreateDevice(IID_IDirect3DRGBDevice,dxbackbuffer, &dxd3ddevice)!=DD_OK){
      dxerror();
    }  
  }  
  // get the surface description so we know the width & height
  if (dxprimary->GetSurfaceDesc(&dxsd)!=DD_OK) dxerror();
  // create the viewport
  if (dxd3d->CreateViewport(&dxd3dviewport, NULL)!=D3D_OK) dxerror();
  ZeroMemory(&dxviewport, sizeof(dxviewport));
  dxviewport.dwSize = sizeof(dxviewport);
  dxviewport.dwX = 0;
  dxviewport.dwY = 0;
  dxviewport.dwWidth = dxsd.dwWidth;
  dxviewport.dwHeight = dxsd.dwHeight;
  dxviewport.dvScaleX = dxsd.dwWidth/2;
  dxviewport.dvScaleY = dxsd.dwHeight/2;
  dxviewport.dvMinZ = 0.0f;
  dxviewport.dvMaxZ = 1.0f;
  dxviewport.dvMaxX = 1.0f;
  dxviewport.dvMaxY = 1.0f;
  if (dxd3ddevice->AddViewport(dxd3dviewport)!=DD_OK) dxerror();
  if (dxd3dviewport->SetViewport(&dxviewport)!=DD_OK) dxerror();
  if (dxd3ddevice->SetCurrentViewport(dxd3dviewport)!=DD_OK) dxerror();
  // material
  dxd3d->CreateMaterial(&dxd3dmat, NULL);
  memset(&dxmat, 0, sizeof(D3DMATERIAL));
  dxmat.dwSize = sizeof(D3DMATERIAL);
  dxmat.diffuse.r = 1.0;
  dxmat.diffuse.g = (D3DVALUE)1.0;
  dxmat.diffuse.b = (D3DVALUE)1.0;
  dxmat.ambient.r = 1.0;
  dxmat.ambient.g = (D3DVALUE)1.0;
  dxmat.ambient.b = (D3DVALUE)1.0;
  dxmat.dwRampSize = 0;
  dxd3dmat->SetMaterial(&dxmat);
  dxd3dmat->GetHandle(dxd3ddevice, &dxhmat);
  dxd3dviewport->SetBackground(dxhmat);
  dxd3d->CreateMaterial(&dxd3dmat, NULL);
  memset(&dxmat, 0, sizeof(D3DMATERIAL));
  dxmat.dwSize = sizeof(D3DMATERIAL);
  dxmat.diffuse.r = (D3DVALUE)1.0;
  dxmat.diffuse.g = (D3DVALUE)1.0;
  dxmat.diffuse.b = (D3DVALUE)1.0;
  dxmat.ambient.r = (D3DVALUE)1.0;
  dxmat.ambient.g = (D3DVALUE)1.0;
  dxmat.ambient.b = (D3DVALUE)1.0;
  dxmat.specular.r = (D3DVALUE)1.0;
  dxmat.specular.g = (D3DVALUE)1.0;
  dxmat.specular.b = (D3DVALUE)1.0;
  dxmat.power = (float)0.5;
  dxmat.dwRampSize = 16;
  dxd3dmat->SetMaterial(&dxmat);
  dxd3dmat->GetHandle(dxd3ddevice, &dxhmat);
  // lighting
  dxd3d->CreateLight(&dxd3dlight, NULL);
  memset(&dxlight, 0, sizeof(D3DLIGHT));
  dxlight.dwSize = sizeof(D3DLIGHT);
  dxlight.dltType = D3DLIGHT_DIRECTIONAL;
  dxlight.dcvColor.r = 0;
  dxlight.dcvColor.g = 0.0;
  dxlight.dcvColor.b = D3DVAL(0.4);
  dxlight.dvAttenuation0 = 0.0;
  dxlight.dvAttenuation1 = 0.0;
  dxlight.dvAttenuation2 = 0.0;
  dxlight.dvPosition.x = 0.0;
  dxlight.dvPosition.y = D3DVAL(0.0);
  dxlight.dvPosition.z = D3DVAL(0);
  dxlight.dvDirection.x = -1;
  dxlight.dvDirection.y = D3DVAL(0.0);
  dxlight.dvDirection.z = D3DVAL(0.25);
  dxd3dlight->SetLight(&dxlight);
  dxd3dviewport->AddLight(dxd3dlight);
  dxd3d->CreateLight(&dxd3dlight, NULL);
  memset(&dxlight, 0, sizeof(D3DLIGHT));
  dxlight.dwSize = sizeof(D3DLIGHT);
  dxlight.dltType = D3DLIGHT_DIRECTIONAL;
  dxlight.dcvColor.r = 0.7;
  dxlight.dcvColor.g = 0.6;
  dxlight.dcvColor.b = D3DVAL(0.2);
  dxlight.dvAttenuation0 = 0.0;
  dxlight.dvAttenuation1 = 0.0;
  dxlight.dvAttenuation2 = 0.0;
  dxlight.dvPosition.x = 0;
  dxlight.dvPosition.y = D3DVAL(0);
  dxlight.dvPosition.z = D3DVAL(0);
  dxlight.dvDirection.x = 1;
  dxlight.dvDirection.y = D3DVAL(0.0);
  dxlight.dvDirection.z = D3DVAL(0.25);
  dxd3dlight->SetLight(&dxlight);
  dxd3dviewport->AddLight(dxd3dlight);
  // texturing
  // tex1
  ZeroMemory(&dxsd, sizeof(dxsd));
  dxsd.dwSize = sizeof(dxsd);
  dxsd.dwFlags = DDSD_CAPS | DDSD_WIDTH | DDSD_HEIGHT;
  dxsd.dwWidth = 64;
  dxsd.dwHeight = 64;
  dxsd.ddsCaps.dwCaps = DDSCAPS_TEXTURE | DDSCAPS_VIDEOMEMORY;
  if(dxdd->CreateSurface(&dxsd, &dxstexture, NULL)!=D3D_OK){
    dxsd.ddsCaps.dwCaps = DDSCAPS_TEXTURE | DDSCAPS_SYSTEMMEMORY;
    dxdd->CreateSurface(&dxsd, &dxstexture, NULL);  
  }
  dxstexture->GetDC(&dxtexturedc);
  for(int i=0;i<64;i++){
    for(int j=0;j<64;j++){
      SetPixel(dxtexturedc, i, j, (65536+256+1)*(long)(255*(sin(i/8.0)*sin(j/5.0)*0.5+0.5)*(sin(j/8.0)*cos(i/15.0)*0.5+0.5)));
    }
  }    
  dxstexture->ReleaseDC(dxtexturedc);
  if(dxstexture->QueryInterface(IID_IDirect3DTexture2, (LPVOID *)&dxtexture) != S_OK) dxerror();
  dxtexture->GetHandle(dxd3ddevice, (DWORD*)&dxhtexture[0]);
  dxtexture->Release();
  // tex2
  ZeroMemory(&dxsd, sizeof(dxsd));
  dxsd.dwSize = sizeof(dxsd);
  dxsd.dwFlags = DDSD_CAPS | DDSD_WIDTH | DDSD_HEIGHT;
  dxsd.dwWidth = 32;
  dxsd.dwHeight = 32;
  dxsd.ddsCaps.dwCaps = DDSCAPS_TEXTURE | DDSCAPS_VIDEOMEMORY;
  if(dxdd->CreateSurface(&dxsd, &dxstexture, NULL)!=D3D_OK){
    dxsd.ddsCaps.dwCaps = DDSCAPS_TEXTURE | DDSCAPS_SYSTEMMEMORY;
    dxdd->CreateSurface(&dxsd, &dxstexture, NULL);  
  }
  dxstexture->GetDC(&dxtexturedc);
  for(int i=0;i<32;i++){
    for(int j=0;j<32;j++){
      if(i>6&&i<32-6){
        SetPixel(dxtexturedc, i, j, (65536+256+1)*(long)(255*(j%2)));
      } else {
        SetPixel(dxtexturedc, i, j, (65536+256+1)*(long)(255*((j+1)%2)));
      }
    }
  }    
  dxstexture->ReleaseDC(dxtexturedc);
  if(dxstexture->QueryInterface(IID_IDirect3DTexture2, (LPVOID *)&dxtexture) != S_OK) dxerror();
  dxtexture->GetHandle(dxd3ddevice, (DWORD*)&dxhtexture[1]);
  dxtexture->Release();
  // state
  dxd3ddevice->SetRenderState(D3DRENDERSTATE_ZENABLE,TRUE);//D3DZB_USEW
  dxd3ddevice->SetRenderState(D3DRENDERSTATE_ZWRITEENABLE,TRUE);
  dxd3ddevice->SetLightState(D3DLIGHTSTATE_MATERIAL,dxhmat);
  dxd3ddevice->SetLightState (D3DLIGHTSTATE_AMBIENT, RGBA_MAKE(0, 0, 0, 0));
  dxd3ddevice->SetRenderState(D3DRENDERSTATE_LIGHTING,TRUE); 
  dxd3ddevice->SetRenderState(D3DRENDERSTATE_TEXTUREPERSPECTIVE,TRUE);
//  dxd3ddevice->SetRenderState(D3DRENDERSTATE_BLENDENABLE, TRUE);
//  dxd3ddevice->SetRenderState(D3DRENDERSTATE_SRCBLEND, D3DBLEND_SRCALPHA);
//  dxd3ddevice->SetRenderState(D3DRENDERSTATE_DESTBLEND, D3DBLEND_INVSRCALPHA);
  matrix=D3DMATRIX(1,0,0,0, 0,1,0,0, 0,0,1,0.5, 0,0,0,1);
  dxd3ddevice->SetTransform(D3DTRANSFORMSTATE_PROJECTION, &matrix);
  matrix=D3DMATRIX(1,0,0,0, 0,1,0,0, 0,0,0.5,0, 0,0,0.5,1);
  dxd3ddevice->MultiplyTransform(D3DTRANSFORMSTATE_PROJECTION, &matrix);
  // load objects
  dxloadobject("tank.3do");
}

void renderobj(dx3dobject obj){
//  D3DVERTEX v[3];
  // transformations
  matrix=D3DMATRIX(1,0,0,0, 0,cos(PI/4),sin(PI/4),0, 0,-sin(PI/4),cos(PI/4),0, 0,0,0,1);
  dxd3ddevice->SetTransform(D3DTRANSFORMSTATE_WORLD, &matrix);
  matrix=D3DMATRIX(cos(4*t),sin(4*t),0,0, -sin(4*t),cos(4*t),0,0, 0,0,1,0, 0,0,0,1);
  dxd3ddevice->MultiplyTransform(D3DTRANSFORMSTATE_WORLD, &matrix);
  // drawing
  if(obj.lists>0){
    for(int i=0;i<obj.lists;i++){
      dxd3ddevice->SetRenderState(D3DRENDERSTATE_TEXTUREHANDLE, dxhtexture[obj.list[i].tex]);
      dxd3ddevice->DrawPrimitive(D3DPT_TRIANGLELIST,D3DVT_VERTEX,&obj.list[i].v[0],obj.list[i].num,D3DDP_WAIT);
    }
  }
  if(obj.strips>0){
    for(int i=0;i<obj.strips;i++){
      dxd3ddevice->SetRenderState(D3DRENDERSTATE_TEXTUREHANDLE, dxhtexture[obj.strip[i].tex]);
      dxd3ddevice->DrawPrimitive(D3DPT_TRIANGLESTRIP,D3DVT_VERTEX,&obj.strip[i].v[0],obj.strip[i].num,D3DDP_WAIT);
    }
  }
}

void render(void){
  ZeroMemory(&dxblt, sizeof(dxblt));
  dxblt.dwSize = sizeof(dxblt);
  if(dxbackbuffer->Blt(NULL,NULL,NULL,DDBLT_WAIT|DDBLT_COLORFILL,&dxblt)!=DD_OK) dxerror();
  D3DRECT rect;
  rect.x1 = 0;rect.y1 = 0;
  rect.x2 = XRES; rect.y2 = YRES;
  if(dxd3dviewport->Clear(1, &rect, D3DCLEAR_ZBUFFER)!=DD_OK) dxerror();
  if (dxd3ddevice->BeginScene()!=D3D_OK) dxerror();
  renderobj(obj);
  if (dxd3ddevice->EndScene()!=D3D_OK) dxerror();
  dxprimary->Flip(NULL,DDFLIP_WAIT);//DDFLIP_NOVSYNC
}

BOOL wininit(HINSTANCE hThisInstance){
  wincl.hInstance = hThisInstance;
  wincl.lpszClassName = szClassName;
  wincl.lpfnWndProc = WindowProcedure;    
  wincl.style = CS_NOCLOSE;               
  wincl.hIcon = LoadIcon(NULL, IDI_APPLICATION);
  wincl.hCursor = LoadCursor(NULL, IDC_ARROW);
  wincl.lpszMenuName = NULL;
  wincl.cbClsExtra = 0;                   
  wincl.cbWndExtra = 0;                   
  wincl.hbrBackground = (HBRUSH) GetStockObject(LTGRAY_BRUSH);
  if(!RegisterClass(&wincl)) return FALSE;
  hwnd = CreateWindowEx(
           WS_EX_TOPMOST,
           szClassName,
           "Tank 3.0",         
           WS_POPUPWINDOW,
           0,
           0,
           XRES,
           YRES, 
           HWND_DESKTOP,  
           NULL,            
           hThisInstance,    
           NULL           
           );
  ShowWindow(hwnd, SW_SHOWMAXIMIZED);
  return true;
}

LRESULT CALLBACK WindowProcedure(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    switch (message){
           case WM_DESTROY:
             PostQuitMessage(0);
           break;
           case WM_KEYDOWN:
             PostQuitMessage(0);
           break;
           default:
           return DefWindowProc(hwnd, message, wParam, lParam);
    }
    return 0;
}

int WINAPI WinMain(HINSTANCE hThisInstance, HINSTANCE hPrevInstance, LPSTR lpszArgument, int nFunsterStil){
  if(!wininit(hThisInstance))winerror();
  dxinit();
  // render
  while ( !bQuit ) {
    if ( PeekMessage( &messages, NULL, 0, 0, PM_REMOVE ) ) {
      if ( messages.message == WM_QUIT ) {
        bQuit=TRUE;
      } else {
        TranslateMessage( &messages );
        DispatchMessage( &messages );
      }
    } else {
      render();
      t+=0.005;
    }
  }  
  dxcleanup();
  DestroyWindow(hwnd);
  return 0;
}

